-- Crappy Button Matching Game 0.2 
-- Alex Carroll
-- 20th july 2005

-- Based off Shine's Snake with Lua <- thanks!

timerbar = loadImage("timer.png")
buttoncircle = loadImage("button-circle.png")
buttonsquare = loadImage("button-square.png")
buttoncross = loadImage("button-cross.png")
buttontriangle = loadImage("button-triangle.png")
buttonup = loadImage("button-up.png")
buttondown = loadImage("button-down.png")
buttonleft = loadImage("button-left.png")
buttonright = loadImage("button-right.png")
buttonfail = loadImage("button-fail.png")
buttonsuccess = loadImage("button-success.png")
presstart = loadImage("presstart.png")
gameoversc = loadImage("gameover.png")

-- wait for start button at boot up

function awaitstart()
	blitImage(0,0, presstart)
	gostart=0
	repeat
		pada = ctrlRead()
		if isCtrlStart(pada) then 
			gostart=1
		end
	until gostart==1
end

-- game over routine (just shows score and waits for start)

function gameover()
	blitImage(0,0, gameoversc)
	fillBackground(47, 191, 432, 208)
	gostart=0
	printDecimal(68, 220, score, 0);
	repeat
		padb = ctrlRead()
		if isCtrlStart(padb) then 
			gostart=1
		end
	until gostart==1
end

-- initialise the variables

level=1
timercount=1
button = {}
nextbutton = 0
nextbuttonpic = ""
rannum = 0
score = 0
high = 0
buttoncounter=1
timer=1
targetImage = 0
clearpad=0
pad=0
allowpad=0

-- set up the random buttons

function newGame()
	flipDrawFrame()
	fillBackground(0, 0, 480, 272)
	for buttonnumber=1,5 do	
		nextbutton=0
		rannum=math.random(1,12)
		if rannum == 1 then
			nextbutton = buttonsquare
			nextbuttonpic = "square"
		end
		if rannum == 2 then
			nextbutton = buttontriangle
			nextbuttonpic = "triangle"
		end
		if rannum == 3 then
			nextbutton = buttoncross
			nextbuttonpic = "cross"
		end
		if rannum == 4 then
			nextbutton = buttoncircle
			nextbuttonpic = "circle"
		end
		if rannum == 5 then
			nextbutton = buttonup
			nextbuttonpic = "up"
		end
		if rannum == 6 then
			nextbutton = buttonup
			nextbuttonpic = "up"
		end
		if rannum == 7 then
			nextbutton = buttondown
			nextbuttonpic = "down"
		end
		if rannum == 8 then
			nextbutton = buttondown
			nextbuttonpic = "down"
		end
		if rannum == 9 then
			nextbutton = buttonleft
			nextbuttonpic = "left"
		end
		if rannum == 10 then
			nextbutton = buttonleft
			nextbuttonpic = "left"
		end
		if rannum == 11 then
			nextbutton = buttonright
			nextbuttonpic = "right"
		end
		if rannum == 12 then
			nextbutton = buttonright
			nextbuttonpic = "right"
		end


		if nextbutton==0 then
			nextbutton=buttoncross
			nextbuttonpic="cross"
		end

		blitImage(64+((buttonnumber-1)*80), 48, nextbutton)	

		if buttonnumber==1 then
			button[1]=nextbuttonpic
		end
		if buttonnumber==2 then
			button[2]=nextbuttonpic
		end
		if buttonnumber==3 then
			button[3]=nextbuttonpic
		end
		if buttonnumber==4 then
			button[4]=nextbuttonpic
		end
		if buttonnumber==5 then
			button[5]=nextbuttonpic
		end
	end
	flipShowFrameV()
end

-- initialise the random number and do other stuff

math.randomseed(os.time())
screenFrame(1, 1)
screenFrame(1, 0)
awaitstart()
newGame()

-- main game loop

while true do

	blitImage(47,191, timerbar)
	fillBackground(432-timer, 191, timer, 17)
	printDecimal(68, 220, score, 0);

	waitVblankStart()

	-- this next bit clears the controller cache (handy)

	if allowpad==0 then
		clearpad=ctrlRead()
	end
	if clearpad==0 then 
		allowpad=1
	end
	if allowpad==1 then
		pad = ctrlRead()
	end
	
	-- handle controller input (much improved over 0.1)

	if isCtrlCircle(pad) then
		if button[buttoncounter] == "circle" then
			blitImage(64+((buttoncounter-1)*80), 48, buttonsuccess)
			buttoncounter=buttoncounter+1
			allowpad=0
			pad=0
			score=score+1
		else
			blitImage(64+((buttoncounter-1)*80), 16*8, buttonfail)
			allowpad=0
			pad=0
			score=score-5
		end
	end

	if isCtrlTriangle(pad) then
		if button[buttoncounter] == "triangle" then
			blitImage(64+((buttoncounter-1)*80), 48, buttonsuccess)
			buttoncounter=buttoncounter+1
			allowpad=0
			pad=0
			score=score+1
		else
			blitImage(64+((buttoncounter-1)*80), 16*8, buttonfail)
			allowpad=0
			pad=0
			score=score-5
		end
	end

	if isCtrlCross(pad) then
		if button[buttoncounter] == "cross" then
			blitImage(64+((buttoncounter-1)*80), 48, buttonsuccess)
			buttoncounter=buttoncounter+1
			allowpad=0
			pad=0
			score=score+1
		else
			blitImage(64+((buttoncounter-1)*80), 16*8, buttonfail)
			allowpad=0
			pad=0
			score=score-5
		end
	end

	if isCtrlSquare(pad) then
		if button[buttoncounter] == "square" then
			blitImage(64+((buttoncounter-1)*80), 48, buttonsuccess)
			buttoncounter=buttoncounter+1
			allowpad=0
			pad=0
			score=score+1
		else
			blitImage(64+((buttoncounter-1)*80), 16*8, buttonfail)
			allowpad=0
			pad=0
			score=score-5
		end
	end

	if isCtrlLeft(pad) then
		if button[buttoncounter] == "left" then
			blitImage(64+((buttoncounter-1)*80), 48, buttonsuccess)
			buttoncounter=buttoncounter+1
			allowpad=0
			pad=0
			score=score+1
		else
			blitImage(64+((buttoncounter-1)*80), 16*8, buttonfail)
			allowpad=0
			pad=0
			score=score-5
		end
	end

	if isCtrlRight(pad) then
		if button[buttoncounter] == "right" then
			blitImage(64+((buttoncounter-1)*80), 48, buttonsuccess)
			buttoncounter=buttoncounter+1
			allowpad=0
			pad=0
			score=score+1
		else
			blitImage(64+((buttoncounter-1)*80), 16*8, buttonfail)
			allowpad=0
			pad=0
			score=score-5
		end
	end

	if isCtrlUp(pad) then
		if button[buttoncounter] == "up" then
			blitImage(64+((buttoncounter-1)*80), 48, buttonsuccess)
			buttoncounter=buttoncounter+1
			allowpad=0
			pad=0
			score=score+1
		else
			blitImage(64+((buttoncounter-1)*80), 16*8, buttonfail)
			allowpad=0
			pad=0
			score=score-5
		end
	end

	if isCtrlDown(pad) then
		if button[buttoncounter] == "down" then
			blitImage(64+((buttoncounter-1)*80), 48, buttonsuccess)
			buttoncounter=buttoncounter+1
			allowpad=0
			pad=0
			score=score+1
		else
			blitImage(64+((buttoncounter-1)*80), 16*8, buttonfail)
			allowpad=0
			pad=0
			score=score-5
		end
	end

	-- repeat if 5 correct buttons are pressed
	
	if buttoncounter>5 then 
		buttoncounter=1
		level=level+1
		newGame()
	end

	timercount=timercount+1
		if timercount==5 then 
			timercount=1
			timer=timer+1
		end

	-- game over situation

	if timer>386 then 
		timer=0
		gameover()
		level=1
		timercount=1
		nextbutton = 0
		nextbuttonpic = ""
		rannum = 0
		score = 0
		high = 0
		buttoncounter=1
		timer=1
		targetImage = 0
		clearpad=0
		pad=0
		allowpad=0
		newGame()
	end

	if score<1 then
		score=0
	end

end

-- eof
